--[[
  _____       _ _     _ ____              _    _    _ _     _                   
 / ____|     (_) |   | |  _ \            | |  | |  | (_)   | |                  
| |  __ _   _ _| | __| | |_) | __ _ _ __ | | _| |__| |_ ___| |_ ___  _ __ _   _ 
| | |_ | | | | | |/ _` |  _ < / _` | '_ \| |/ /  __  | / __| __/ _ \| '__| | | |
| |__| | |_| | | | (_| | |_) | (_| | | | |   <| |  | | \__ \ || (_) | |  | |_| |
 \_____|\__,_|_|_|\__,_|____/ \__,_|_| |_|_|\_\_|  |_|_|___/\__\___/|_|   \__, |
                                                                           __/ |
                                                                          |___/ 


Guild Bank History by Kiki (@kikiadoc - megaserver eu)

Guide et explications ( à intégrer sur la page de ESOUI)
*********************************************************************************

Hi guys,

This addon is for you, guild leaders, officers, guild mates, if you want to easily track what's happened in yours guilds' banks.

If you use Roomba (great addon) or if your guild mates are used to get a stack of items and put it back a few second later withdrawing only one item, your guild bank history will be full of movements that are not relevant.

Then, it is very hard to know what are the withdrawals and deposits at a glance.

GuildBankHistory will help you, showing what are the relevant banking movements each time you open a guild bank.
When you are online, but away from a banker, GuildBankHistory tracks what append if you configured an alert.
So use /gbh command or click the GuildBankHistory button in the chat window, to display a journal of relevant movements anywhere (current journal or previsously computed histories at guildbanks)

GuildBankHistory is also able to alert you when a matching bank movement occured (per bank criteria: deposit/withdraw/color/level of item/gold coins) (no alert when in combat)

You can filter journals and histories by color and level and hide deposits, withdrawals or compactions.

No boring configuration needed, just click the new button available when you open one of your guildbanks:
The GuildBankHistory window displays your banking movements since you opened it before. (and before, and before ...)

GuildBankHisotry is available in French (my native) & English.
DE translation is in progress.

Some commands are available to setup GuildBankHistory if needed
/gbh detail : toggle option to display details of banking movements in chat, not only summaries
/gbh delay 0..6 : setup initial scan delay to N*20 seconds (default 3)
/gbh button 3..10 : setup time-shift of scan after opening a guildbank (guildbankhistory button availability) to n*0.5 seconds (default 4)

Feel free to report bugs & requirements

Have fun !
@kikiadoc (liveeu)


PS: Roomba, AdvancedFilters compliant

Thanks :
Some concepts from Garkin -- http://www.esoui.com/forums/showthread.php?t=4323
Chat button code copied/modified from AlphaLemming's craftstore -- http://www.esoui.com/downloads/info1047-CraftStore.html
Banners from http://www.network-science.de/ascii/


TODO (may be^^):
blink chat icon when movements detected (jirk request)
Setup Page to update technical constants, delays and so on ?
force LUA max memory if below 60Mo ?
filter by text ?
option to alert when in combat ?

*********************************************************************************
1.0.9
Api version TESO 2.1

1.0.8
Can pin/unpin guildbankhistory window

1.0.7
A click on a player name in history displays synthesys of player's movements
New confirmation dialog to clear a bank
Code refactoring : getBankImage() - optimized

1.0.6
Typos (EN)
Banking movement synthesis is now sorted by type of items
Bug fix : wrong date in history when time is between midnight - timezone offset and midnight

1.0.5
Gold tracking alerts
Scan when opening a guildbank can be deferred: [b]/gbh button [i]n[/i][/b] to setup button availability (and scan) delay to n*0.5 seconds n=3..10 (default 4)

1.0.4
Message in history if movements may be missing between 2 scans
Initial scan delayed by 60 seconds by default ([b]/gbh delay [i]n[/i][/b] to setup inital scan delai to nx20 seconds) (Quadro request)
2 seconds delay before enabling button in guildbank (crash game fix ?) (Quadro report, not able to replicate this crash)
Only counts of movements are displayed in chat by default when opening a guildbank ([b]/gbh detail[/b] to toggle this option) (Jirk request)

1.0.3
checkbox to show self movements in bank journal (self movements are now hidden by default)
no alert if self movement
Small button in chat window to open GuildBankHistory main window (Quadro request)
Gold tracking (in bank history and jornal but no alerts yet)
Bug fix

1.0.2
When back online, display "some movements may be missing between timestamp and timestamp" message if last scan is before the oldest available movement in history
Changed labels in dropdowns (trash now is any)
Code refactoring, so savedVariables are reinitialized

1.0.1
add journals of banks based on history
add alerts on movements in history
filter summaries by color/withdraw/déposit
filter journals by color/withdraw/déposit/compactions
EN use by default if tranlation is missing

1.0.0
initial public release

*********************************************************************************


if Roomba and Roomba.WorkInProgress and Roomba.WorkInProgress() then return end --support for Roomba



]]--


k_GBH = {

  debug = false,                -- mode debug
	name = "GuildBankHistory",
	version="1.0.9",
	expectedSavedVersion=19,      -- numero de version des savedVariables attendu
	author="@kikiadoc", 

	L = {},                       -- traductions
	
	savedVariables={},            -- gestion des savedVariables
	
	
	-- privates
	selfName = GetDisplayName(),   -- nom du compte de jeu
	uiBankName = nil,              -- nom de la banque actuellement affichée au niveau de l'ui (nil = pas de banque)
	gameBankName = nil,            -- nom de la banque actuellement disponible au niveau du jeu (nil = pas de banque)
	uiDisplayModeJournal = false,  -- dernier type d'affichage de l'ui (history/journal) 
	savedVariablesConverted=nil,   -- Indique la version précédente des savedvariables lors d'une conversion (pour affichage au debut si besoin)
	welcomeDone=false,             -- Indique que le welcome message a ete indiqué
  defferedScan=3,                -- 3*cCyclicTimer secondes de delai avant le chargement des banques à l'initialisation (surchargé par savedvariables si indiqué)
  buttonDelay=2000,              -- delai d'affichage du bouton apres avoir recu les events de contenu de la guildbank (surchargé par savedvariables si indiqué)
  
  -- constantes	
  cHistoryCountMax=1300,         -- nombre d'entrées dans l'historique maximum avant compactage
  cHistoryCountObj=900,          -- nombre d'entrées dans l'historique maximum apres compactage
  cJournalCountMax=1200,         -- nombre d'entrées max dans le journal avant compactage
  cJournalCountObj=900,          -- nombre d'entrées max dans le journal apres compactage
	cAutoScanMin=120,              -- timer mini pour scan banque
  cAutoScanMax=180,              -- timer maxi pour scan banque
  cDefaultDefferedScan=3,        -- deferred scan par default
  cDefaultButtonDelay=2000,      -- deferred scan par default sur le bouton dans la banque de guilde ( 2 secondes )
  cCyclicTimer=20,               -- nb de secondes de declenchement du timer
}	

--------------------------------------------------------
-- Forward definitions 
-------------------------------------------------------- 
local getBankImage,displaySynthesysForUser, uiLoadBankSelect

--[[
-------------------------------------------------------- 
 _______          _     
|__   __|        | |    
   | | ___   ___ | |___ 
   | |/ _ \ / _ \| / __|
   | | (_) | (_) | \__ \
   |_|\___/ \___/|_|___/

-------------------------------------------------------- 
]]--

-------------------------------------------------------- 
-- local debug
-------------------------------------------------------- 
local function D(text, ...)
  if k_GBH.debug then 
    if type(text) == "string" then 
      d(k_GBH.L.Name..text, ...)
    else
      d(k_GBH.L.Name,text, ...)
    end
  end
end

-------------------------------------------------------- 
-- Copie d'une structure par valeur -- http://lua-users.org/wiki/CopyTable
-- param orig l'element a copier
-- return la copie
-------------------------------------------------------- 
local function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

-------------------------------------------------------- 
-- Creation des alertes recues à vide
-------------------------------------------------------- 
local bankAlertInitObject = { a = {lastAlertTimestamp = 0, lastAlertOverflow=0}, r= {lastAlertTimestamp = 0, lastAlertOverflow=0} }
local function createBankAlerts()
  local alerts={}
  -- alertes selon couleur
  for i,_ in pairs(k_GBH.L.uiColor) do
    alerts[i] = deepcopy(bankAlertInitObject)
  end
  -- Alerte sur Gold
  alerts['po'] = deepcopy(bankAlertInitObject)
  return alerts
end

-------------------------------------------------------- 
-- Normalization des savedVariables en fonction des montées de version
-- NE PAS OUBLIER DE MODIFIER k_GBH.expectedSavedVersion
-- si des elements de normalization sont ajoutés
-------------------------------------------------------- 
local function normalizeSavedVariables()

  -- faut-il normaliser les savedVariables ?
  if k_GBH.savedVariables.savedVersion ~= k_GBH.expectedSavedVersion then

    if not k_GBH.savedVariables.savedVersion then k_GBH.savedVariables.savedVersion = 0 end
    
    -- sauve la version des savedvariables qui ont été converties  
    k_GBH.savedVariablesConverted = k_GBH.savedVariables.savedVersion
    
    -- migration version 1.0.0 vers 1.0.2 (version 13 des savedvariables) (globalement, c'est un reinit des savedvariables)
    if k_GBH.savedVariables.savedVersion < 13 then 
    
      -- stockage des banks est reset
      k_GBH.savedVariables.banks = {}

      -- display ajout/retrait/quality sont supprimés au profit d'attributs pour chaque banque
      k_GBH.savedVariables.displayQuality = nil 
      k_GBH.savedVariables.displayAdd = nil 
      k_GBH.savedVariables.displayDel = nil 

      -- version mise en oeuvre
      k_GBH.savedVariables.savedVersion = 13
    end

    -- migration version 1.0.2 vers 1.0.5 (version 15 des savedvariables) 
    if k_GBH.savedVariables.savedVersion < 15 then 

      -- Ajout de parametres pour le tracking dans les banks existantes si besoin
      for bankName,bank in pairs(k_GBH.savedVariables.banks) do
          -- creation des alertes de la banque si besoin
          if not bank.alerts then
            bank.alerts = createBankAlerts()
          end
          -- tracking des pos si besoin (la version précédente n'avait pas 'po' dans les alertes)
          if not bank.alerts['po'] then
            bank.alerts['po'] = deepcopy(bankAlertInitObject)
          end
      end

      -- version mise en oeuvre
      k_GBH.savedVariables.savedVersion = 15
    end


    -- migration version 1.0.5 vers 1.0.6 (version 19 des savedvariables) 
    if k_GBH.savedVariables.savedVersion < 19 then 

      -- La version 1.0.6 implique un champ type et name dans les historiques et dans la dernier bankImage
      for bankName,bank in pairs(k_GBH.savedVariables.banks) do
          -- balayage de la bank.lastImage pour ajouter le type
          if bank.lastImage then
            for id,item in pairs(bank.lastImage) do
              item.type=GetItemLinkItemType(item.link) or 0
              if item.link then
                local name, _, _, objId, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,_ = ZO_LinkHandler_ParseLink(item.link)
                item.name=name or ""
              else
                item.name = ""
              end
            end
          end
          -- balayage des historiques pour ajouter le type et convertir le tableau en un tableau indexé par des entiers
          for i,history in ipairs(bank.history) do
            -- balayage des elements de l'historique
            local newDelta = {}
            for id,item in pairs(history.delta) do
              item.type=(item.link and GetItemLinkItemType(item.link)) or 0
              if item.link then
                local name, _, _, objId, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,_ = ZO_LinkHandler_ParseLink(item.link)
                item.name=name or ""
              else
                item.name = ""
              end
              table.insert(newDelta,item)
            end
            -- tri le tableau du nouveau delta
            table.sort(newDelta,function (a,b) return (a.type < b.type) or ((a.type == b.type) and (a.name < b.name)) end)
            -- remplace le delta précédent
            history.delta=newDelta
          end
      end

      -- version mise en oeuvre
      k_GBH.savedVariables.savedVersion = 19
    end

    
    -- Normalisation terminée
    k_GBH.savedVariables.savedVersion = k_GBH.expectedSavedVersion
  end
end
--------------------------------------------------------
--  Gestion du parametre buttonDelay 
-------------------------------------------------------- 
local function setButtonDelay(n)
  k_GBH.savedVariables.buttonDelay = n or k_GBH.cDefaultButtonDelay
end
local function getButtonDelay()
  return k_GBH.savedVariables.buttonDelay or k_GBH.cDefaultButtonDelay
end

--------------------------------------------------------
--  Gestion du parametre defferedScan 
-------------------------------------------------------- 
local function setDefferedScan(n)
  k_GBH.savedVariables.defferedScan = n or k_GBH.cDefaultDefferedScan
  k_GBH.defferedScan = k_GBH.savedVariables.defferedScan
end
local function getDefferedScan(n)
  return k_GBH.savedVariables.defferedScan or k_GBH.cDefaultDefferedScan
end

-------------------------------------------------------- 
-- Creation d'une banque nommée bankName si besoin, avec les valeurs par defaults
-- Retourne la banque existante ou la banque nouvellement crée
-------------------------------------------------------- 
local function getBank(bankName)
  assert(bankName and (#bankName > 0), "invalid bankName nil or empty string")
  local bank = k_GBH.savedVariables.banks[bankName]
  if not bank then
    bank = 
    {
      name=bankName,
      lastScan = nil,
      lastModified = nil,
      lastImage= nil,
      history={},
      historyCount=0,
      journal= nil,
      displayAdd=true,
      displayDel=true,
      displayQuality=ITEM_QUALITY_TRASH,
      alertWithdrawQuality = nil,
      alertDepositQuality = nil,
      alertWithdrawLevel = nil,
      alertDepositLevel = nil,
      scheduledGetJournal = 0,
      alerts = createBankAlerts(),
    }
    k_GBH.savedVariables.banks[bankName] = bank
  end

  return bank
end

--------------------------------------------------------
-- Retourne le nom de la banque actuellement disponible en jeu ou nil 
-------------------------------------------------------- 
local function getGameBankName()
  return k_GBH.gameBankName
end
--------------------------------------------------------
-- Indique le nom de la banque disponible en jeu (ou nil)
-------------------------------------------------------- 
local function setGameBankName(bankName)
  k_GBH.gameBankName = bankName
end


--[[
-------------------------------------------------------- 
 _____        _       _    _                     
|  __ \      | |     | |  | |                    
| |  | | __ _| |_ ___| |__| | ___ _   _ _ __ ___ 
| |  | |/ _` | __/ _ \  __  |/ _ \ | | | '__/ _ \
| |__| | (_| | ||  __/ |  | |  __/ |_| | | |  __/
|_____/ \__,_|\__\___|_|  |_|\___|\__,_|_|  \___|
                                                 
-------------------------------------------------------- 
]]--

-------------------------------------------------------- 
-- Calcul du decalage entre heure GMT et heure locale
-- return le delta en seconde
-------------------------------------------------------- 
local function getTimeZoneOffset()
  -- Si calcul pas déjà fait
  if k_GBH.timeZoneOffset==nil then
    local ssm = GetSecondsSinceMidnight()
    local now = GetTimeStamp()
    k_GBH.timeZoneOffset = ssm - (now % (60*60*24))
  end
  return k_GBH.timeZoneOffset
end

-------------------------------------------------------- 
-- Edition de la date/heure depuis un timestamp du jeu
-- return la date, hh, mm, ss
-------------------------------------------------------- 
local function getRawDateTime(timestamp)
  local tm = timestamp + getTimeZoneOffset()
  local date = GetDateStringFromTimestamp(timestamp)
  tm = tm % (24*60*60)
  local hh = math.floor(tm / 3600)
  tm = tm - hh*3600 
  return date, hh, math.floor(tm/60), tm % 60
end

-------------------------------------------------------- 
-- Edition de la date/heure depuis un timestamp du jeu
-- return la date/heure editée
-------------------------------------------------------- 
local function getFullDateTime(timestamp)
  return string.format("%s %02d:%02d:%02d", getRawDateTime(timestamp))
end

-------------------------------------------------------- 
-- Afffichage d'une heure depuis un timestamp
-- return la date/heure editée
-------------------------------------------------------- 
local function getTime(timestamp)
  local _,hh,mm,ss = getRawDateTime(timestamp)
  return string.format("%02d:%02d:%02d", hh,mm,ss)
end

--[[
-------------------------------------------------------- 
 _    _ _____ 
| |  | |_   _|
| |  | | | |  
| |  | | | |  
| |__| |_| |_ 
 \____/|_____|
                                                 
-------------------------------------------------------- 
]]--

-------------------------------------------------------- 
-- Arret du déplacement de la fenetre
-- Appellé depuis l'XML de l'UI
-------------------------------------------------------- 
function k_GBH.uiOnMoveStop()
  -- sauvegarde la position
  k_GBH.savedVariables.left = k_GBH_:GetLeft()
  k_GBH.savedVariables.top = k_GBH_:GetTop()
end

-------------------------------------------------------- 
-- Ferme l'ui d'historique
-- Si force, force l'ui meme si option "pin window" est active
-------------------------------------------------------- 
local function uiHide(force)
  if (not force) and k_GBH.savedVariables.pinned then
    -- Pour l'instant, si pas force close et option pin window, on ne ferme pas l'ui
    return
  end
  if not k_GBH_:IsHidden() then
    k_GBH_:SetHidden(true)
  end
end

-------------------------------------------------------- 
-- Callback du bouton de fermeture de l'UI
-- Appelée depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiCloseButton()
  uiHide(true)
end

-------------------------------------------------------- 
-- Positionne les texture du bouton de pinnage
-------------------------------------------------------- 
local function  uiPinSetupTexture()
  if k_GBH.savedVariables.pinned then
    k_GBH_PinButton:SetNormalTexture("/esoui/art/buttons/radiobuttondown.dds")
    k_GBH_PinButton:SetMouseOverTexture("/esoui/art/buttons/radiobuttondown.dds")
    k_GBH_PinButton:SetPressedTexture("/esoui/art/buttons/radiobuttondown.dds")
    k_GBH_PinButton:SetPressedMouseOverTexture("/esoui/art/buttons/radiobuttondown.dds")
  else
    k_GBH_PinButton:SetNormalTexture("/esoui/art/buttons/radiobuttonup.dds")
    k_GBH_PinButton:SetMouseOverTexture("/esoui/art/buttons/radiobuttonup.dds")
    k_GBH_PinButton:SetPressedTexture("/esoui/art/buttons/radiobuttonup.dds")
    k_GBH_PinButton:SetPressedMouseOverTexture("/esoui/art/buttons/radiobuttonup.dds")
  end 
end 
-------------------------------------------------------- 
-- Callback du bouton de pinnage de la fenetre
-- Appelée depuis l'XML
-- Modifie le status de pinnage et
-- Modifie l'aspect du bouton de pinnage
-------------------------------------------------------- 
function k_GBH.uiPinButton()
-- toggle le status de pinnage de la fenetre
  k_GBH.savedVariables.pinned = (k_GBH.savedVariables.pinned == false) or false
  uiPinSetupTexture() 
end
-------------------------------------------------------- 
-- gestion du slider de l'historique
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiOnSliderMove(self,value,eventReason)
  k_GBH_Message:SetScrollPosition(k_GBH_Message:GetNumHistoryLines()-value)
end

-------------------------------------------------------- 
-- gestion de la mousewheel de l'historiqie
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiMouseWheel(self,delta)
  k_GBH_Slider:SetValue(math.floor(k_GBH_Slider:GetValue()-delta))
end


-------------------------------------------------------- 
-- Positionne l'etat d'un checkbox(control,status)
-- control : la checbox à positionner
-- status : true si checbox à cocher, false sinon
-- Attention, ne provoque aucune callback eventuelle (à charge de l'appelant si besoin)
-------------------------------------------------------- 
local function uiSetCheckbox(control,status)
  if status then
    control:SetNormalTexture("/esoui/art/buttons/checkbox_checked.dds") 
  else
    control:SetNormalTexture("/esoui/art/buttons/checkbox_unchecked.dds") 
  end
end

-------------------------------------------------------- 
-- Positionne le slider dela zone de message
-------------------------------------------------------- 
local function setupSlider()
  -- gestion du slider
  local nbLines = k_GBH_Message:GetNumHistoryLines()
  local nbVisible = k_GBH_Message:GetNumVisibleLines()
  if nbLines<=nbVisible then
    k_GBH_Slider:SetHidden(true)
  else
    k_GBH_Slider:SetMinMax(0,nbLines)
    k_GBH_Slider:SetValue(nbLines)
    k_GBH_Slider:SetHidden(false)
  end
end

-------------------------------------------------------- 
-- indique la banque qui est affichée dans l'ui
-------------------------------------------------------- 
local function setUiBankName(bankName)
  k_GBH.uiBankName = bankName
end

-------------------------------------------------------- 
-- retourne la banque actuellement affichée au niveau de l'ui
-------------------------------------------------------- 
local function getUiBankName()
  return k_GBH.uiBankName
end

--------------------------------------------------------
-- Calcul le libelle selon un niveau 
--------------------------------------------------------
local function uiAlertLevelLbl(i)
  if i== nil then return nil end
  if i > 50 then return "Niv. V"..(i-50) end
  return 'Niv. '..i
end

--------------------------------------------------------
-- Handler des liens cliqués dans la zone centrale 
--------------------------------------------------------
local function linkHandler(link, button, uiObj)
  local name,typeId,type, objId, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,_ = ZO_LinkHandler_ParseLink(link)
  if type== CHARACTER_LINK_TYPE then
    displaySynthesysForUser(objId)
  else
    -- handler par defaut
    ZO_LinkHandler_OnLinkMouseUp(link, button, uiObj)
  end
end

-------------------------------------------------------- 
-- Demande confirmation Effacement de l'historique de la banque actuelle
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiClearCurrentBank()

  local oldBankName = getUiBankName()
  assert(oldBankName,'impossible de k_GBH.uiClearCurrentBank: empty getUiBankName')

  ZO_Dialogs_ShowDialog("GBH_CONFIRM_CLEAR",{bankName = oldBankName}, {mainTextParams = {oldBankName}})

end
-------------------------------------------------------- 
-- Effacement de l'historique de la banque actuelle
-------------------------------------------------------- 
local function doClearCurrentBank(oldBankName)

  assert(oldBankName,'impossible de k_GBH.doClearCurrentBank: empty oldBankName')
  
  -- pas de banque par defaut
  setUiBankName(nil)
  
  -- effacement de la banque
  k_GBH.savedVariables.banks[oldBankName] = nil  

  -- Rechargement de la combo
  uiLoadBankSelect()
  
  -- Affichage d'aucune bnque....
  k_GBH.uiDisplayBank(nil)
  

end


-------------------------------------------------------- 
-- Initialisation de l'ui
-- Appelée au démarrage du plugin et ralise différentes opérations d'initiaion de l'UI
-------------------------------------------------------- 
local function uiInit()

  k_GBH_Version:SetText(k_GBH.author.." "..k_GBH.version)

  -- si position sauvegardée
  if k_GBH.savedVariables.top then
    k_GBH_:ClearAnchors()
    k_GBH_:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, k_GBH.savedVariables.left, k_GBH.savedVariables.top)
  end
  -- positionnement en XML semble buggé, necessaire de le faire dans le code semble-t-il
  k_GBH_Message:SetHandler("OnLinkMouseUp", function(self, _, link, button) return linkHandler(link, button, self) end)

  -- Ajoute le bouton d'ouverture de l'historique dans le menu de la guildbank
  assert(ZO_GuildBankMenuBar,"GuildBankHistory error: Game Global Variable ZO_GuildBankMenuBar is not defined")

  --[[
  local fancyButton =
    {
      descriptor = "GuildBankHistory",
      normal = "EsoUI/Art/mainmenu/menubar_journal_up.dds",
      pressed = "EsoUI/Art/mainmenu/menubar_journal_down.dds",
      disabled = "EsoUI/Art/mainmenu/menubar_journal_disabled.dds",
      highlight = "EsoUI/Art/mainmenu/menubar_journal_over.dds",
      callback = k_GBH.ComputeAndDisplay,
    }
  k_GBH.openButton = ZO_MenuBar_AddButton(ZO_GuildBankMenuBar, fancyButton)
  ]]--
  
  -- Creation du bouton d'ouverture de guildBankHistory
  -- Plutot que de creer un bouton de menu, qui peut interférer avec d'autres plugins, 
  -- Ajout dans le bouton de retait du bouton guildbank, ce qui permet de ne pas
  -- influencer les "lastbutton/firstButton" et les schenes des autres plugins
  assert(ZO_GuildBankMenuBarButton2,"ZO_GuildBankMenuBarButton2 not defined, may be an upgrade in game ?")
  k_GBH.bankButton = WINDOW_MANAGER:CreateControlFromVirtual("k_GBH_GuildBankHistoryBtn",ZO_GuildBankMenuBarButton2,"k_GBH_GuildBankHistoryBtnVirtual")
  k_GBH.bankButton:SetAnchor(LEFT, ZO_GuildBankMenuBarButton2, RIGHT, 10,0)
    
  -- positionnemenet des labels traduits
  k_GBH_BankAlertDepositLbl:SetText(k_GBH.L.uiAlertDepositLbl)
  k_GBH_BankAlertWithdrawLbl:SetText(k_GBH.L.uiAlertWithdrawLbl)
  k_GBH_BankAlertDepositOrLbl:SetText(k_GBH.L.uiAlertOrLbl)
  k_GBH_BankAlertDepositOrLbl2:SetText(k_GBH.L.uiAlertOrLbl)
  k_GBH_BankAlertWithdrawOrLbl:SetText(k_GBH.L.uiAlertOrLbl)
  k_GBH_BankAlertWithdrawOrLbl2:SetText(k_GBH.L.uiAlertOrLbl)
  k_GBH_ShowAddLbl:SetText(k_GBH.L.uiAdd)
  k_GBH_ShowDelLbl:SetText(k_GBH.L.uiDel)     
  k_GBH_ShowCompLbl:SetText(k_GBH.L.uiComp)     
  k_GBH_ShowSelfLbl:SetText(k_GBH.L.uiSelf)     
  k_GBH_ShowOrLbl:SetText(k_GBH.L.uiOrLbl)
  k_GBH_DeleteLastHistory:SetText(k_GBH.L.uiDeleteLastHist)

  -- dropdown de selection de niveau de filtrage d'affichage par quality
  local fct = function(quality)
    -- recupere la banque et indique le niveau qualité a afficher
    getBank(getUiBankName()).displayQuality = quality
    -- Affiche la banque proposee si disponible
    k_GBH.uiDisplayBank(getUiBankName())
  end
  local combo = k_GBH_ShowColor.m_comboBox
  combo:ClearItems()
  combo:AddItem(combo:CreateItemEntry(k_GBH.L.uiShowQualityNone, function () fct(nil) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  for quality,name in pairs(k_GBH.L.uiColor) do
    combo:AddItem(combo:CreateItemEntry(name, function () fct(quality) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end

  -- dropdown de selection de niveau de filtrage d'affichage par level
  local fct = function(level)
    -- recupere la banque et indique le niveau qualité a afficher
    getBank(getUiBankName()).displayLevel = level
    -- Affiche la banque proposee si disponible
    k_GBH.uiDisplayBank(getUiBankName())
  end
  local combo = k_GBH_ShowLevel.m_comboBox
  combo:ClearItems()
  combo:AddItem(combo:CreateItemEntry(k_GBH.L.uiShowLevelNone, function () fct(nil) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  for i=5, 50, 5 do
    combo:AddItem(combo:CreateItemEntry(uiAlertLevelLbl(i), function () fct(i) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end
  for i=1, 14 do
    combo:AddItem(combo:CreateItemEntry(uiAlertLevelLbl(50+i), function () fct(50+i) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end

  
  -- dropdown de selection de niveau de filtrage d'alerte de dépose
  local fct = function (quality)
    -- recupere la banque et indique l'alerte
    getBank(getUiBankName()).alertDepositQuality = quality
  end
  local combo = k_GBH_BankAlertDepositQuality.m_comboBox
  combo:ClearItems()
  combo:AddItem(combo:CreateItemEntry(k_GBH.L.uiAlertDepositQualityNone, function () fct(nil) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  for quality,name in pairs(k_GBH.L.uiAlertDeposit) do
    combo:AddItem(combo:CreateItemEntry(name, function () fct(quality) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end

  -- dropdown de selection de niveau de filtrage d'alerte de dépose
  local fct = function (level)
    -- recupere la banque et indique l'alerte
    getBank(getUiBankName()).alertDepositLevel = level
  end
  local combo = k_GBH_BankAlertDepositLevel.m_comboBox
  combo:ClearItems()
  combo:AddItem(combo:CreateItemEntry(k_GBH.L.uiAlertDepositLevelNone, function () fct(nil) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  for i=5, 50, 5 do
    combo:AddItem(combo:CreateItemEntry(uiAlertLevelLbl(i), function () fct(i) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end
  for i=1, 14 do
    combo:AddItem(combo:CreateItemEntry(uiAlertLevelLbl(50+i), function () fct(50+i) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end

  -- dropdown de selection de niveau de filtrage d'alerte de retraits
  local fct = function (quality)
    -- recupere la banque et indique l'alerte
    getBank(getUiBankName()).alertWithdrawQuality = quality
  end
  local combo = k_GBH_BankAlertWithdrawQuality.m_comboBox
  combo:ClearItems()
  combo:AddItem(combo:CreateItemEntry(k_GBH.L.uiAlertWithdrawQualityNone, function () fct(nil) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  for quality,name in pairs(k_GBH.L.uiAlertWithdraw) do
    combo:AddItem(combo:CreateItemEntry(name, function () fct(quality) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end

  -- dropdown de selection de niveau de filtrage d'alerte de retrait
  local fct = function (level)
    -- recupere la banque et indique l'alerte
    getBank(getUiBankName()).alertWithdrawLevel = level
  end
  local combo = k_GBH_BankAlertWithdrawLevel.m_comboBox
  combo:ClearItems()
  combo:AddItem(combo:CreateItemEntry(k_GBH.L.uiAlertWithdrawLevelNone, function () fct(nil) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  for i=5, 50, 5 do
    combo:AddItem(combo:CreateItemEntry(uiAlertLevelLbl(i), function () fct(i) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end
  for i=1, 14 do
    combo:AddItem(combo:CreateItemEntry(uiAlertLevelLbl(50+i), function () fct(50+i) end),ZO_COMBOBOX_SUPRESS_UPDATE)
  end
  
  -- dialog de confirmation d'effacement de la banque
  local confirm = {
      title = { text = k_GBH.L.uiDialogClearTitle },
      mainText = { text = k_GBH.L.uiDialogClearMessage },
      buttons = {
         { text = k_GBH.L.uiDialogClearConfirm, callback = function(dialog) doClearCurrentBank(dialog.data.bankName) end },
         { text = k_GBH.L.uiDialogClearCancel  }
      }
  }
  ZO_Dialogs_RegisterCustomDialog("GBH_CONFIRM_CLEAR", confirm)
  
  -- setup texture du bouton de pinnage de la fenete
  uiPinSetupTexture()
  
end

-------------------------------------------------------- 
-- ajoute un history a l'affichage
-- History est l'historyique a afficher en plus dans la fenetre
-------------------------------------------------------- 
local function uiDisplayHistory(bank,history)
  local add=0
  local sub=0
  -- Si pas de selection de qualité, ni de niveau, on selectionne tout à priori
  local always = (not bank.displayQuality) and (not bank.displayLevel)
  for i,v in ipairs(history.delta) do
    local eligible = always or (bank.displayQuality and v.quality and (v.quality >= bank.displayQuality)) or (bank.displayLevel and v.level and (bank.displayLevel <= v.level))
    if v.stackCount > 0 then
      if bank.displayAdd and eligible then
        k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.ItemAdd,v.link,v.stackCount))
      end
      add = add+1
    else
      if bank.displayDel and eligible then
        k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.ItemSub,v.link,- v.stackCount))
      end
      sub = sub+1
    end
  end
  -- Synthèse des operations sur les POs
  local poMsg = zo_strformat( ((history.deltaPo and (history.deltaPo >= 0)) and k_GBH.L.PoAdd) or k_GBH.L.PoSub, math.abs(history.deltaPo))
  -- Synthèse des ajouts/retraits
  k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiBankHistoryTrailer, add, sub, poMsg))
end


-------------------------------------------------------- 
-- Affichage de l'historique d'une banque 
-- bank est la banque a afficher
-- ne doit etre appelée que depuis k_GBH.uiDisplayBank
-------------------------------------------------------- 
local function uiDisplayBankHistory(bank)

  -- dernier historique scanné
  local lastHistory = nil

  -- Si il y a des historiques
  local histories = bank.history
  if histories then
    for i,history in ipairs(histories) do
      -- Affichage du précédent historique si il existe
      if lastHistory then
        k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiBankHistoryHeader,getFullDateTime(lastHistory.timestamp),getFullDateTime(history.timestamp)),255,255,0,0)
        uiDisplayHistory(bank,lastHistory)
      end
      lastHistory = history
    end
  end
    
  -- Affichage du dernier hisorique
  if lastHistory then
    k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiBankHistoryLastHeader,getFullDateTime(lastHistory.timestamp)),255,255,0,0)
    uiDisplayHistory(bank,lastHistory)
  end
  
  -- si il y a eu un scan....
  local lastScan = bank.lastScan
  if lastScan then
    k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiBankHistoryLastScan,getFullDateTime(lastScan),bank.name))
  else
    k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiBankHistoryNoScan, bank.name),255,0,0,0)
  end
  
  -- si la banque de jeu est indisponible
  if not getGameBankName() then
    -- indique que pour actualiser, il faut aller a la banque et appuyer sur le bouton de la fenetre de banque
    k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiBankHistoryActualizationGoBank))
  -- si la banque affichée dans l'ui n'est pas celle disponible en jeu
  elseif getGameBankName() ~= getUiBankName() then
    -- indique que pour actualiser, il faut switch de banque
    k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiBankHistoryActualizationSwitch),255,0,0,0)
  end
end

-------------------------------------------------------- 
-- Affichage du journal d'une banque 
-- bank est la banque a afficher
-- ne doit etre appelée que depuis k_GBH.uiDisplayBank
-------------------------------------------------------- 
local function uiDisplayBankJournal(bank)

  if bank.journal then
    local lastDate = nil
    local n = 0
    for i,operation in pairs(bank.journal.operations) do
      if operation.gapStart then
        -- message indiquant un ecart dans le tracking de la banque entre gapStart et gapEnd
        local message = zo_strformat( k_GBH.L.uiJournalGap, getFullDateTime(operation.gapStart), getFullDateTime(operation.gapEnd))
        k_GBH_Message:AddMessage(message,255,0,255,0)
      else
        -- mouvement normal d'ajout / retrait
        n = n + 1
        local editedTime = getFullDateTime(operation.timestamp)
        if date ~= lastDate then
          k_GBH_Message:AddMessage(string.format("*** %s ***",date),255,255,0,0)
          lastDate = date
        end
        -- Affichage forcé si pas de critere d'affichage ou que c'est un mouvement de PO
        local eligible = (not bank.displayQuality) and (not bank.displayLevel) or (operation.link == nil)
        -- Eligible affichage forcé ou si la qualité ou le niveau match
        eligible = eligible or
                   (bank.displayQuality and operation.quality and (operation.quality >= bank.displayQuality)) or 
                   (bank.displayLevel and operation.level and (operation.level>= bank.displayLevel))
        -- Affichage uniquement si ce sont des mouvements d'un autre joueur ou que l'on a l'option d'affichage des mouvements personnels
        eligible = eligible and (bank.displaySelf or (operation.player ~= k_GBH.selfName))
  
        -- Si eligible, affiche un retait/ajout/compactage
        if eligible then
          if (operation.count > 0) and bank.displayAdd then
            local message = zo_strformat( (operation.link and k_GBH.L.uiJournalItemAdd) or k_GBH.L.uiJournalPoAdd, editedTime, 
                                          ZO_LinkHandler_CreateLink(operation.player, nil, CHARACTER_LINK_TYPE, operation.player),
                                          operation.count, operation.link, operation.nbOper )
            -- local message = zo_strformat( (operation.link and k_GBH.L.uiJournalItemAdd) or k_GBH.L.uiJournalPoAdd, editedTime, operation.player, operation.count, operation.link, operation.nbOper )
            k_GBH_Message:AddMessage(message,0,128,0,0)
          elseif (operation.count < 0) and bank.displayDel then
            local message = zo_strformat( (operation.link and k_GBH.L.uiJournalItemDel) or k_GBH.L.uiJournalPoDel, editedTime, 
                                          ZO_LinkHandler_CreateLink(operation.player, nil, CHARACTER_LINK_TYPE, operation.player),
                                          - operation.count, operation.link, operation.nbOper )
            k_GBH_Message:AddMessage(message,128,0,0,0)
          elseif (operation.count == 0) and bank.displayComp then
            local message = zo_strformat( (operation.link and k_GBH.L.uiJournalItemCom) or k_GBH.L.uiJournalPoCom, editedTime, 
                                          ZO_LinkHandler_CreateLink(operation.player, nil, CHARACTER_LINK_TYPE, operation.player),
                                          operation.count, operation.link, operation.nbOper )
            k_GBH_Message:AddMessage(message,64,64,64,0)
          end
        end
      end
    end
    k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiJournalSumUp,getFullDateTime(bank.journal.lastScanTimestamp), getFullDateTime(bank.journal.lastOperationTimestamp)),255,255,0,0)
    if n == 0 then
      k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiJournalSumUpEmpty,getFullDateTime(bank.journal.lastOperationTimestamp)),255,0,0,0)
    end
  else
    -- journal vide
    -- si tracking actif
    if bank.alertWithdrawQuality or bank.alertDepositQuality or bank.alertDepositLevel or bank.alertWithdrawLevel or bank.alertDepositGold or bank.alertWithdrawGold then
      -- message patientez !
      k_GBH_Message:AddMessage(k_GBH.L.uiJournalEmpty,255,255,0,0)
    else
      -- message pas de tracking en cours
      k_GBH_Message:AddMessage(k_GBH.L.uiJournalNoTracking,255,0,0,0)
    end
  end
  k_GBH_Message:AddMessage(k_GBH.L.uiJournalLookGuildHistory,255,255,0,0)
end

-------------------------------------------------------- 
-- Affichage ou masque les widgets de filtrage de liste
-- hidden = true /false selon qu'il faut masquer ou non
-- journalMode = true si afficahge en mode journal
-------------------------------------------------------- 
local function uiSetupShowWidget(hidden, journalMode)
    k_GBH_ShowAddLbl:SetHidden(hidden)
    k_GBH_ShowDelLbl:SetHidden(hidden)
    k_GBH_ShowCompLbl:SetHidden(hidden or not journalMode)
    k_GBH_ShowSelfLbl:SetHidden(hidden or not journalMode)
    k_GBH_ShowAdd:SetHidden(hidden)
    k_GBH_ShowDel:SetHidden(hidden)
    k_GBH_ShowComp:SetHidden(hidden or not journalMode)
    k_GBH_ShowSelf:SetHidden(hidden or not journalMode)
    k_GBH_ShowColor:SetHidden(hidden)
    k_GBH_ShowOrLbl:SetHidden(hidden)
    k_GBH_ShowLevel:SetHidden(hidden)
end

-------------------------------------------------------- 
-- Affichage d'une banque (historique ou journal) 
-- Bankname est le nom de la banque a afficher (ou nil)
-- mode = 'h' | 'j' | nil  (history mode, journal mode, nil is last used mode)  
-------------------------------------------------------- 
function k_GBH.uiDisplayBank(bankName,mode)

  k_GBH_Message:Clear()
  
  -- uiDisplayModeJournal = false si mode histroy, true si mode journal
  if mode=='j' then
    k_GBH.uiDisplayModeJournal = true
  elseif mode=='h' then
    k_GBH.uiDisplayModeJournal = false
  end
  
  -- Indique la banque chargée dans l'ui
  
  setUiBankName(bankName)

  if not bankName then 
    -- TODO reorganiser l'UI pour avoir un enable/disable global
    -- descctive les boutons d'action
    k_GBH_BankHistory:SetHidden(true)
    k_GBH_BankJournal:SetHidden(true)
    k_GBH_BankReinit:SetHidden(true)
   
    -- desactive les boutons de filtrage d'affichage
    uiSetupShowWidget(true)
    
    -- desactive les boutons d'alertes
    k_GBH_BankAlertDepositLbl:SetHidden(true)
    k_GBH_BankAlertWithdrawLbl:SetHidden(true)
    k_GBH_BankAlertDepositOrLbl:SetHidden(true)
    k_GBH_BankAlertWithdrawOrLbl:SetHidden(true)
    k_GBH_BankAlertDepositOrLbl2:SetHidden(true)
    k_GBH_BankAlertWithdrawOrLbl2:SetHidden(true)
    k_GBH_BankAlertDepositOrLbl2:SetHidden(true)
    k_GBH_BankAlertWithdrawGoldLbl:SetHidden(true)
    k_GBH_BankAlertDepositGoldLbl:SetHidden(true)
    k_GBH_BankAlertDepositQuality:SetHidden(true)
    k_GBH_BankAlertWithdrawQuality:SetHidden(true)
    k_GBH_BankAlertWithdrawGold:SetHidden(true)
    k_GBH_BankAlertDepositLevel:SetHidden(true)
    k_GBH_BankAlertWithdrawLevel:SetHidden(true)
    k_GBH_BankAlertDepositGold:SetHidden(true)
    k_GBH_BankAlertWithdrawGold:SetHidden(true)
    k_GBH_DeleteLastHistory:SetHidden(true)

  else
    local bank = getBank(bankName)

    -- options afficahge d'ajout/retrait  
    uiSetupShowWidget(false, k_GBH.uiDisplayModeJournal)

    -- Active les boutons d'action
    k_GBH_BankHistory:SetHidden(false)
    k_GBH_BankJournal:SetHidden(false)
    k_GBH_BankReinit:SetHidden(false)

    k_GBH_BankAlertDepositLbl:SetHidden(false)
    k_GBH_BankAlertWithdrawLbl:SetHidden(false)
    k_GBH_BankAlertDepositOrLbl:SetHidden(false)
    k_GBH_BankAlertWithdrawOrLbl:SetHidden(false)
    k_GBH_BankAlertDepositOrLbl2:SetHidden(false)
    k_GBH_BankAlertWithdrawOrLbl:SetHidden(false)
    k_GBH_BankAlertWithdrawOrLbl2:SetHidden(false)
    k_GBH_BankAlertDepositGoldLbl:SetHidden(false)
    k_GBH_BankAlertWithdrawGoldLbl:SetHidden(false)

    -- le bouton de supression de l'historique n'est disponible que si l'ui et le jeu concernent la meme banque, et que c'est l'historique qui va etre affiché
    k_GBH_DeleteLastHistory:SetHidden(false)
    k_GBH_DeleteLastHistory:SetEnabled((not k_GBH.uiDisplayModeJournal) and getGameBankName() and (getGameBankName() == getUiBankName()))
  

    -- positionne les checkboxes
    uiSetCheckbox(k_GBH_ShowAdd,bank.displayAdd)
    uiSetCheckbox(k_GBH_ShowDel,bank.displayDel)

    if k_GBH.uiDisplayModeJournal then
      uiSetCheckbox(k_GBH_ShowComp,bank.displayComp)
      uiSetCheckbox(k_GBH_ShowSelf,bank.displaySelf)
    end
    
    -- Positionne la qualité d'affichage des elements
    k_GBH_ShowColor.m_comboBox:SetSelectedItem(k_GBH.L.uiColor[bank.displayQuality])

    -- Positionne le niveau d'affichage des elements
    k_GBH_ShowLevel.m_comboBox:SetSelectedItem(uiAlertLevelLbl(bank.displayLevel))
  
    -- Positionne les parametres d'alerte
    k_GBH_BankAlertDepositQuality:SetHidden(false)
    k_GBH_BankAlertDepositQuality.m_comboBox:SetSelectedItem(k_GBH.L.uiAlertDeposit[bank.alertDepositQuality])
    k_GBH_BankAlertWithdrawQuality:SetHidden(false)
    k_GBH_BankAlertWithdrawQuality.m_comboBox:SetSelectedItem(k_GBH.L.uiAlertWithdraw[bank.alertWithdrawQuality])
    k_GBH_BankAlertDepositLevel:SetHidden(false)
    k_GBH_BankAlertDepositLevel.m_comboBox:SetSelectedItem(uiAlertLevelLbl(bank.alertDepositLevel))
    k_GBH_BankAlertWithdrawLevel:SetHidden(false)
    k_GBH_BankAlertWithdrawLevel.m_comboBox:SetSelectedItem(uiAlertLevelLbl(bank.alertWithdrawLevel))
    k_GBH_BankAlertDepositGold:SetHidden(false)
    uiSetCheckbox(k_GBH_BankAlertDepositGold,bank.alertDepositGold)
    k_GBH_BankAlertWithdrawGold:SetHidden(false)
    uiSetCheckbox(k_GBH_BankAlertWithdrawGold,bank.alertWithdrawGold)
  
    -- affiche le detail du journal ou des historiques
    if k_GBH.uiDisplayModeJournal then
      uiDisplayBankJournal(bank)
    else
      uiDisplayBankHistory(bank)
    end
  end

  setupSlider()

end

-------------------------------------------------------- 
-- Affichage d'un historique de banque
-- Appelé par Clic sur le bouton d'affichage de l'historique 
-------------------------------------------------------- 
function k_GBH.uiButtonDisplayBankHistory()
  k_GBH.uiDisplayBank(getUiBankName(),'h')
end

-------------------------------------------------------- 
-- Affichage d'un journal de banque
-- Appelé par Clic sur le bouton d'affichage du journal 
-------------------------------------------------------- 
function k_GBH.uiButtonDisplayBankJournal()
  k_GBH.uiDisplayBank(getUiBankName(),'j')
end

-------------------------------------------------------- 
-- chargement de la liste déroulante de selection d'une banque
-- et activation callback de selection vers k_GBH.uiDisplayBank(bankName)
-------------------------------------------------------- 
uiLoadBankSelect = function ()
  local combo = k_GBH_BankSelect.m_comboBox
  combo:ClearItems()
  local fct = function (_, choiceText, choice)
      k_GBH.uiDisplayBank(choiceText)
  end
  
  for bankName,bank in pairs(k_GBH.savedVariables.banks) do
    local entry = combo:CreateItemEntry(bankName, fct)
    combo:AddItem(entry,ZO_COMBOBOX_SUPRESS_UPDATE)
  end
  combo:UpdateItems()
  k_GBH_Message:Clear()
end


-------------------------------------------------------- 
-- positionne la bank dans la liste de la dropdown
-- bankName est le nom de la banque a faire apparaitre dans la dropdown
-------------------------------------------------------- 
local function uiSetBankSelect(bankName)  
  k_GBH_BankSelect.m_comboBox:SetSelectedItem(bankName or '')
end

-------------------------------------------------------- 
-- Affichage de l'ui
-- type = h ou j selon le type à utiliser (historique ou journal)
-------------------------------------------------------- 
local function uiShow(type)
  -- Enable mouse pointer
  SetGameCameraUIMode(true)         
  -- affiche la fenetre
  k_GBH_:SetHidden(false)
  -- recharge la liste des banques
  uiLoadBankSelect()
  -- Affiche la banque proposee selon le type
  uiSetBankSelect(getUiBankName())
  k_GBH.uiDisplayBank(getUiBankName(),type)
end

-------------------------------------------------------- 
-- Suppression du denier element de l'historique
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiDeleteLastHist()
  
  local bankName = getUiBankName() 
  
  -- vérification que l'ui et le jeu pointe sur la meme banque
  assert(bankName and (#bankName > 0) and (bankName == getGameBankName()),"UI and GAME not pointing on the same bank")
  
  -- recuperer la banque
  local bank = getBank(bankName)
  
  -- Si aucun historique, retourne sans rien faire
  if not bank.history then return end
  
  if #bank.history > 0 then
    table.remove(bank.history)
  end

  local newBank = getBankImage()
  -- marque le timestamp actuel dans l'image
  bank.lastScan = GetTimeStamp()
  -- stocke l'image de la bank, pour les calculs suivants
  bank.lastImage = newBank
  -- reaffiche l'historique
  uiShow('h')
end

-------------------------------------------------------- 
-- CLick sur l'option alerte sur ajout de po
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiAlertAddGoldClicked()
  local bank = getBank(getUiBankName())
  bank.alertDepositGold = not bank.alertDepositGold
  uiSetCheckbox(k_GBH_BankAlertDepositGold,bank.alertDepositGold)
end
-------------------------------------------------------- 
-- CLick sur l'option alerte sur retrait de po
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiAlertDelGoldClicked()
  local bank = getBank(getUiBankName())
  bank.alertWithdrawGold = not bank.alertWithdrawGold
  uiSetCheckbox(k_GBH_BankAlertWithdrawGold,bank.alertWithdrawGold)
end

-------------------------------------------------------- 
-- CLick sur l'option d'ajout
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiShowAddClicked()
  local bank = getBank(getUiBankName())
  bank.displayAdd = not bank.displayAdd
  uiSetCheckbox(k_GBH_ShowAdd,bank.displayAdd)
  -- Affiche la banque proposee si disponible
  k_GBH.uiDisplayBank(getUiBankName())
end

-------------------------------------------------------- 
-- CLick sur l'option de retrait
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiShowDelClicked()
  local bank = getBank(getUiBankName())
  bank.displayDel = not bank.displayDel
  uiSetCheckbox(k_GBH_ShowDel,bank.displayDel)
  -- Affiche la banque proposee si disponible
  k_GBH.uiDisplayBank(getUiBankName())
end

-------------------------------------------------------- 
-- CLick sur l'option de compactage
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiShowCompClicked()
  local bank = getBank(getUiBankName())
  bank.displayComp = not bank.displayComp
  uiSetCheckbox(k_GBH_ShowComp,bank.displayComp)
  -- Affiche la banque proposee si disponible
  k_GBH.uiDisplayBank(getUiBankName())
end
-------------------------------------------------------- 
-- CLick sur l'option d'afficahge de ses propres movements
-- Appel depuis l'XML
-------------------------------------------------------- 
function k_GBH.uiShowSelfClicked()
  local bank = getBank(getUiBankName())
  bank.displaySelf = not bank.displaySelf
  uiSetCheckbox(k_GBH_ShowComp,bank.displaySelf)
  -- Affiche la banque proposee si disponible
  k_GBH.uiDisplayBank(getUiBankName())
end
-------------------------------------------------------- 
-- Enable/disable guildbankhistory button
-------------------------------------------------------- 
local function uiBankButtonEnable(enable)
  if enable then
    k_GBH.bankButton:SetEnabled(true)
  else
    k_GBH.bankButton:SetEnabled(false)
  end
end

--------------------------------------------------------
-- Affiche un message d'alerte au milieu de l'écran
--------------------------------------------------------
local function uiAlertMessage(message)
  CENTER_SCREEN_ANNOUNCE:AddMessage(0, CSA_EVENT_SMALL_TEXT, SOUNDS.LOCKPICKING_UNLOCKED, message)
end

--------------------------------------------------------
-- Ajoute une alerte dans les messages d'alerte 
-- bankName nom de la banque concernée
-- message message a afficher
-- critere qualité de l'objet concerné ou 'po' pour le gold
-- typeOp type d'operation ('a' ou 'r')
-- si une alerte a été déclenchée depuis moins de 4 secondes, avec le meme critere/typeoperation, alors on affiche un message d'overflow uniquement
-------------------------------------------------------- 
local function uiPutInAlertQueue(bankName,message,critere,typeOp)
  -- dans tous les cas, on place le message d'alerte dans le chat
  d(message)
  
  local bank = getBank(bankName)
  local al = bank.alerts[critere][typeOp]
  
  assert(al,"invalid bank.alerts[critere][typeOp]")
  
  local now = GetTimeStamp()
  -- Si il y a une alerte depuis moins de 4 secondes
  if al.lastAlertTimestamp > now - 4 then
    -- test si le message d'overflow n'est pas déjà indiqué
    if al.lastAlertOverflow == 0 then
      -- affiche le message d'overflow
      al.lastAlertOverflow = now
      if critere == 'po' then
        uiAlertMessage(zo_strformat( (typeOp=='a' and k_GBH.L.AlertMoreAddPo) or k_GBH.L.AlertMoreDelPo ,bankName))
      else
        uiAlertMessage(zo_strformat( (typeOp=='a' and k_GBH.L.AlertMoreAdd) or k_GBH.L.AlertMoreDel ,bankName, k_GBH.L.uiColor[critere]))
      end
    end
    return
  end
  
  -- Affiche le message d'alerte
  al.lastAlertTimestamp = now
  al.lastAlertOverflow = 0
  uiAlertMessage(message)
end



--------------------------------------------------------
-- Affiche la synthèse des mouvements d'un compte 
--------------------------------------------------------
displaySynthesysForUser = function(account)
  -- recupere la banque affichée actuellement
  local bank = getBank(getUiBankName())
  local journal = bank.journal
  -- balayage du journal
  if journal then
    -- construction de l'historique des mouvements de ce compte selon le contenu de l'historique
    local userHistory = {}
    local darkZone = false
    local fromTimestamp = GetTimeStamp() -- premiere date/heure a prendre en compte
    local toTimestamp = 0 -- derniere date/heure a prendre en compte
    for i,operation in ipairs(journal.operations) do
      -- d(account,operation.player)
      -- examine si une zone d'ombre dans l'historique est concernée par cet account 
      if operation.gapStart and (operation.gapEnd >= fromTimestamp) then
        -- il y a des zone d'ombre dans l'historique
        darkZone = true
      elseif operation.player == account then
        -- gestion des date/heure de debut/fin
        if fromTimestamp > operation.timestamp then
          fromTimestamp = operation.timestamp
        end
        if toTimestamp < operation.timestamp then
          toTimestamp = operation.timestamp
        end
        local key, name,typeId,type, objId, _
        if operation.link then
          -- mouvement avec un objet
          name, _, _, objId  = ZO_LinkHandler_ParseLink(operation.link)
          local quality = GetItemLinkQuality(operation.link) or 0
          local level = GetItemLinkRequiredLevel(operation.link) or 0
          local vetLevel = GetItemLinkRequiredVeteranRank(operation.link) or 0
          if vetLevel > 0 then level = 50+vetLevel end
          key=objId..'_'.. level ..'_'..quality
        else
          -- mouvement de PO
          key = "_PO"
        end
        if not userHistory[key] then
          -- nouvelle entrée
          userHistory[key] = deepcopy(operation)
          userHistory[key].type = (operation.link and GetItemLinkItemType(operation.link)) or 99999
          userHistory[key].name = name or 'po'
          userHistory[key].from = operation.timestamp
          userHistory[key].to = operation.timestamp
        else
          -- cumul
          local history = userHistory[key]
          if history.from > operation.timestamp then
            history.from = operation.timestamp
          end
          if history.to < operation.timestamp then
            history.to = operation.timestamp
          end
          history.timestamp = operation.timestamp -- conserve la derenier date/heure
          history.count = history.count + operation.count
          history.nbOper = history.nbOper + operation.nbOper
        end
      end        
    end
    -- Construction de la synthèse
    local userSynthesys = {}
    local totalNbOper = 0
    for key,history in pairs(userHistory) do
      totalNbOper = totalNbOper + history.nbOper
      table.insert(userSynthesys,history)
    end
    
    -- tri par type et nom de la synthese
    table.sort(userSynthesys, function (a,b) return (a.type < b.type) or  ((a.type == b.type) and (a.name < b.name)) end)
    
    
    -- ajout dans la zone de l'UI de la synthèse pour le compte utilisateur
    uiSetupShowWidget(true) -- masque les widget liés au filtrage
    k_GBH_Message:Clear()
    for i, history in ipairs(userSynthesys) do
      if history.count > 0 then
        k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiUserItemAdd,account,history.link,history.count,history.nbOper, getFullDateTime(history.from), (history.from ~= history.to) and (" - "..getFullDateTime(history.to)) ))
      elseif history.count < 0 then
        k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiUserItemDel,account,history.link,- history.count, history.nbOper, getFullDateTime(history.from), (history.from ~= history.to) and (" - "..getFullDateTime(history.to)) ))
      end
    end
    k_GBH_Message:AddMessage(zo_strformat(k_GBH.L.uiUser,totalNbOper, account, getFullDateTime(fromTimestamp), getFullDateTime(toTimestamp)))
    -- FIXME indiquer si il y a des darkzones
  else
    -- pas de journal .....
    d('no journal')
  end

  -- slider
  setupSlider()
 
 
 
 
    --[[
        operations[key] = 
          {
            timestamp=eventTime,
            player=displayName,
            count = addCount,
            nbOper=1,
            quality = quality,
            level=level,
            link = link
          }
    ]]--
end


--[[
-------------------------------------------------------- 
 _______ ____   ____  _   _______ _____ _____   _____ 
|__   __/ __ \ / __ \| | |__   __|_   _|  __ \ / ____|
   | | | |  | | |  | | |    | |    | | | |__) | (___  
   | | | |  | | |  | | |    | |    | | |  ___/ \___ \ 
   | | | |__| | |__| | |____| |   _| |_| |     ____) |
   |_|  \____/ \____/|______|_|  |_____|_|    |_____/ 
                                                                                            
-------------------------------------------------------- 
]]--

-------------------------------------------------------- 
-- Affichage Tooltips
-- @param text texte de la tooltipi
-- @param anchor objet d'interface sur lequel positionner le tooltip
-- @param onTop indique si doit etre positionner au dessus de l'objet ou en dessous
-------------------------------------------------------- 
function k_GBH.toolTipShow(text,anchorObject, onTop)
  if not k_GBH.tooltip then
    k_GBH.tooltip = WINDOW_MANAGER:CreateTopLevelWindow("k_GBH_ToolTipUI")
    k_GBH.tooltipText = WINDOW_MANAGER:CreateControl("k_GBH_ToolTipUIText",k_GBH.tooltip,CT_LABEL)
    k_GBH.tooltipText:SetFont("ZoFontGame")
    k_GBH.tooltipText:SetDrawLevel(4)
    k_GBH.tooltipText:SetDrawTier(3)
    k_GBH.tooltipText:SetDrawLayer(2)
    k_GBH.tooltipText:SetClampedToScreen(true)
    k_GBH.tooltipText:SetClampedToScreenInsets(-8,-8,6,6)
    local bg = WINDOW_MANAGER:CreateControlFromVirtual("k_GBH_ToolTipUITextBG",k_GBH.tooltipText,"ZO_DefaultBackdrop")
    bg:SetDrawLayer(1)
    k_GBH.tooltipText:SetHidden(true)
  end

  k_GBH.tooltip:SetTopmost(true)
  k_GBH.tooltipText:ClearAnchors()
  if onTop then
    k_GBH.tooltipText:SetAnchor(BOTTOMRIGHT,anchorObject,TOPLEFT,-3,3)
  else
    k_GBH.tooltipText:SetAnchor(TOPRIGHT,anchorObject,BOTTOMLEFT,-3,3)
  end
  k_GBH.tooltipText:SetText(text)
  k_GBH.tooltipText:SetHidden(false)
end
-------------------------------------------------------- 
-- Effacement tooltip
-------------------------------------------------------- 
function k_GBH.toolTipHide(text,anchorObject)
  k_GBH.tooltipText:SetHidden(true)
end


--[[
-------------------------------------------------------- 
  _____      _            _     
 / ____|    | |          | |    
| |     __ _| | ___ _   _| |___ 
| |    / _` | |/ __| | | | / __|
| |___| (_| | | (__| |_| | \__ \
 \_____\__,_|_|\___|\__,_|_|___/
 
-------------------------------------------------------- 
]]--

-------------------------------------------------------- 
-- Construction de l'image de la banque disponible dans le jeu
-- (tableau indexe par les id/caract des objets contenant des [link,stackCount,delta,quality,level])
-- return bankImage
-------------------------------------------------------- 
getBankImage = function ()

  local bankImage={}

  local bagCache = SHARED_INVENTORY:GenerateFullSlotData(nil, BAG_GUILDBANK)

  for slotIndex,data in pairs(bagCache) do

    local link = GetItemLink(BAG_GUILDBANK,slotIndex)
    if link then
      local name, _, _, objId, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,_ = ZO_LinkHandler_ParseLink(link)
      if objId then
        local stackCount=data.stackCount
        -- local iconFile = data.iconFile
        local quality = GetItemLinkQuality(link) or 0
        local level = GetItemLinkRequiredLevel(link) or 0
        local vetLevel = GetItemLinkRequiredVeteranRank(link) or 0
        local type = GetItemLinkItemType(link) or 0
        if vetLevel > 0 then level = 50+vetLevel end
        
        -- Stockage dans le tableau en construction, par id, en cumulant les quantités des objets
        id = objId..'_'..level..'_'..quality
        bankImage[id] = {
          -- id = id,
          -- iconFile = tostring(iconFile),
          name = name or '',
          link = tostring(link),
          stackCount = stackCount + ((bankImage[id] and bankImage[id].stackCount) or 0),
          quality = quality,
          level=level,
          type=type,
        }
      end
    end
  end

  
  return bankImage
end

-------------------------------------------------------- 
-- Calcul de la différence entre deux bankImage (newBank,OldBank)
-- return une table contenant des [link,stackCount,delta,quality,level,type]
-- le stackcount est positif si ajout, négatif si retrait
-------------------------------------------------------- 
local function computeDelta(newBank,oldBank)
  local delta = {}
  for id,item in pairs(newBank) do
    if oldBank[id]==nil then
      -- Item ajouté
      delta[id] = deepcopy(newBank[id])
    elseif oldBank[id].stackCount ~= newBank[id].stackCount then
      -- quantité différente
      delta[id] = deepcopy(newBank[id])
      delta[id].stackCount = newBank[id].stackCount - oldBank[id].stackCount   
    end
  end
  for id,item in pairs(oldBank) do
    if newBank[id]==nil then
      -- Item totalement retiré
      delta[id] = deepcopy(oldBank[id])
      delta[id].stackCount = - delta[id].stackCount   
    end
    -- le cas quantité différente a été traité au dessus
  end
  
  -- tri du delta selon le type des objets
  local sortedDelta = {}
  for id,movement in pairs(delta) do
    table.insert(sortedDelta,movement)
  end
  table.sort(sortedDelta,function (a,b) return (a.type < b.type) or  ((a.type == b.type) and (a.name < b.name))end)
  
  return sortedDelta
end

-------------------------------------------------------- 
-- Banque disponible, analyse de l'évolution et mise à jour de l'historique
-- return true si l'historique a été modifié, false sinon 
-------------------------------------------------------- 
local function analyseBank(bankName)
  
  -- Creation de l'entrée de banque si besoin
  local bank = getBank(bankName)
  
  -- Recupere le contenu de la banque
  local newBankImage = getBankImage()

  -- Construit une image dans la bank si elle n'existe pas, en copiant la nouvelle image
  if not bank.lastImage then
    -- Pas de précédente image, on construit un historique de cette banque from scratch
    bank.lastScan = GetTimeStamp()
    bank.lastModified = GetTimeStamp()
    bank.lastImage=deepcopy(newBankImage)
    bank.lastPo = GetGuildBankedMoney()
    -- Indique que c'est le premier acces a cette banque
    d(zo_strformat(k_GBH.L.BankRecorded,bankName))
  end 

  -- on a newBank et bankImage, calcul du delta
  local delta = computeDelta(newBankImage,bank.lastImage)
  local nb = #delta
  
  -- si il y a des différences.... ou que l'on a pris/deposé des PO
  local po = GetGuildBankedMoney()
  if (nb > 0) or (po ~= bank.lastPo) then
    -- Ajoute la differece dans l'historique (delta = le delta, timestamp = la date/heure de precedent scan sans différence)
    table.insert(bank.history,{ delta=delta, timestamp=bank.lastModified, nb=nb, deltaPo=po - (bank.lastPo or po) } )
    bank.lastModified = GetTimeStamp()
    bank.lastPo= po
    bank.historyCount = bank.historyCount + nb
  end
  
  -- marque le timestamp actuel dans l'image
  bank.lastScan = GetTimeStamp()
  -- stocke l'image de la bank
  bank.lastImage = newBankImage
  
  -- Si trop d'elements dans l'historique potentiellement....
  if bank.historyCount > k_GBH.cHistoryCountMax then
    local beforeNb = bank.historyCount    
    -- recalcul la taille exacte de l'historique (car des historiques ont pu etre supprimés)
    local nb = 0
    for i,hist in ipairs(bank.history) do
      nb = nb + hist.nb
    end
    bank.historyCount = nb
    -- si apres vérification, il y a toujours trop d'entrée historisées.... on en retire !
    while bank.historyCount > k_GBH.cHistoryCountObj do
      local deleted = table.remove(bank.history,1)
      bank.historyCount = bank.historyCount - deleted.nb
    end
    -- Affiche la synthèse du compactage
    d(zo_strformat(k_GBH.L.BankHistoryCompacted,bank.name,beforeNb,bank.historyCount))
      
  end
  
  return notEmpty ~= nil
end

-------------------------------------------------------- 
-- Affiche les alertes d'un element d'historique(bankName,History) dans le chat
-------------------------------------------------------- 
local function displayHistoryInChat(bankName,history)
  d(zo_strformat(k_GBH.L.DisplayBankHistoryHeader,bankName,getFullDateTime(history.timestamp)))
  local bank = getBank(bankName)
  local add=0
  local sub=0
  for i,v in ipairs(history.delta) do
    if v.stackCount > 0 then
      if k_GBH.savedVariables.displayDetailsInChat then
        if (bank.alertDepositQuality and v.quality and (v.quality >= bank.alertDepositQuality)) or (bank.alertDepositLevel and v.level and (v.level >= bank.alertDepositLevel)) then
          d(zo_strformat(k_GBH.L.AlertHistoryOperationAdd,bankName, v.stackCount,v.link))
        end
      end
      add = add+1
    else
      if k_GBH.savedVariables.displayDetailsInChat then
        if (bank.alertWithdrawQuality and v.quality and (v.quality >= bank.alertWithdrawQuality)) or (bank.alertWithdrawLevel and v.level and (v.level >= bank.alertWithdrawLevel)) then
          d(zo_strformat(k_GBH.L.AlertHistoryOperationDel,bankName, -v.stackCount,v.link))
        end
      end
      sub = sub+1
    end
  end
  
  if sub > 0 then
    d(zo_strformat(k_GBH.L.DisplayBankHistoryTrailerAlert, add, sub))
  else
    d(zo_strformat(k_GBH.L.DisplayBankHistoryTrailer, add, sub))
  end
end

-------------------------------------------------------- 
-- Banque disponible, lance un recalcul et reafiche la fenetre d'historique
-- (appelé par un clic sur le bouton dans le menu de la guildbank)
-------------------------------------------------------- 
function k_GBH.ComputeAndDisplay()
  if not getGameBankName() then
    --- Click sur le bouton de menu alors que le chargement n'est pas terminé..... ou autre raison
    d(k_GBH.L.BankNotYetAvailable)
    return
  end
  local guildbankid=GetSelectedGuildBankId() or 0
  local bankName=tostring(GetGuildName(guildbankid)) or 0
  -- reanalyse la bank
  analyseBank(bankName)
  -- Indique la derniere banque à utiliser pour l'UI
  setUiBankName(bankName)
  -- affiche l'historuque
  uiShow('h')
end

-------------------------------------------------------- 
-- Indique l'etat de disponibilité de la guildbank dans le jeu
-- Flag = true, bank disponible
-- Flag = false, bank indisponible
-- Positionne GameBankName avec le nom de la banque si disponible (nil sinon)
-- Si Banque disponible, on calcul la différence et on l'affiche eventuellement en chat
-- Si banque non disponible on efface l'ui
-- Appelé lorsque l'ouverture de la banque est complete (apres timer etc...)
-------------------------------------------------------- 
local function setGameBankAvailable(flag)

  if flag then
      -- recupere la banque actuellement disponible
      local guildbankid=GetSelectedGuildBankId() or 0
      local bankName=tostring(GetGuildName(guildbankid)) or 0
      
      if guildbankid==0 or bankName==0 or bankName=='' then
        d(k_GBH.L.BankNotAvailable)
        return
      end
    
      -- indique la banque disponible  
      setGameBankName(bankName)
      local bank = getBank(bankName)    
      
      -- Examine si il y a des modifs
      if analyseBank(bankName) then
        -- il y a des modifs, on affiche le dernier historique dans le chat (ou son résumé)
        displayHistoryInChat(bankName,bank.history[#bank.history])
      else
        -- pas de modif dans la banque
        df(k_GBH.L.BankNotModified,bankName,getFullDateTime(bank.lastModified))
      end
      
      -- La banque est disponible
      uiBankButtonEnable(true)
  else
      -- banque plus disponible
      -- marque que le scan n'est pas en cours
      k_GBH.ScanTargetTime = nil
      -- marque la bank comme non disponible
      setGameBankName(nil)
    
      uiBankButtonEnable(false)
      uiHide()
  end
end

-------------------------------------------------------- 
-- scan une réponse historique de guilde du serveur
--
-- params: guildId,lastOperationTimestamp,previousOperations
-- guildId = numero de guilde a scanner
-- lastOperationTimestamp = timestamp de derniere operation précédente
-- previousOperations = operations précédente dans laquelles cumuler les nouvelles (ou ni)
--
-- return: operations, oldestTimestamp,newestTimestamp ou nil si aucune opérations n'est disponible dans l'historique
-- operations=les operations analusées (tableau par ID d'objet d'un {timestamp,player=@name,count(<0 retrait > 0 ajout),nbOper=nb operations cumulées, quality,link}
-- oldestTimestamp = plus ancien timestamp du scan
-- newestTimestamp = plus recent timestamp du scan
-------------------------------------------------------- 
local function scanServerResponse(guildId,lastOperationTimestamp,previousOperations)
 
  local nbOp = GetNumGuildEvents(guildId, GUILD_HISTORY_BANK)
  D('nbop='..nbOp)
  if nbOp==0 then
    return nil
  end
  local operations = previousOperations or {}
  local oldestTimestamp = GetTimeStamp()
  local newestTimestamp = lastOperationTimestamp or 0
  for i = 1, nbOp do
    local eventType, secsSinceEvent, displayName, count, link = GetGuildEventInfo(guildId, GUILD_HISTORY_BANK,i)
    
    -- Calcul de la date/heure de l'operation
    local eventTime = GetTimeStamp() - secsSinceEvent

    -- calcul du timetamp mini /maxi des données recues
    if eventTime < oldestTimestamp then
      oldestTimestamp = eventTime
    end
    if eventTime > newestTimestamp then
      newestTimestamp = eventTime
    end

    -- si cet element n'a pas été déjà pris en compte
    if eventTime > lastOperationTimestamp then 

      local type = ComputeGuildHistoryEventSubcategory(eventType, GUILD_HISTORY_BANK)
      local addCount = (type==GUILD_HISTORY_BANK_DEPOSITS and count) or (-count) 
      local quality = 0
      local level = 0
      local key = nil

      -- Vérif qu'il y a un objet concerné (sinon, c'est des POs)
      if link then
        local _, _, _, objId, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,_ = ZO_LinkHandler_ParseLink(link)
        -- Verif qu'il y a bien un identifiant d'objet...
        if objId then 
          quality = GetItemLinkQuality(link) or 0
          level = GetItemLinkRequiredLevel(link) or 0
          local vetLevel = GetItemLinkRequiredVeteranRank(link) or 0
          if vetLevel > 0 then level = 50+vetLevel end
          key=objId..'_'.. level ..'_'..quality..'_'..displayName
        end
      else
        -- retrait/depot de PO
        key = "PO_"..displayName
        -- comme link == nil, cela indique un retrait de PO
      end
      
      if key then
        -- Creation ou mise à jour d'une entrée dans le dernier journal
        local entry = operations[key]
        if not entry then
          -- pas d'entrée précedente
          operations[key] = 
          {
            timestamp=eventTime,
            player=displayName,
            count = addCount,
            nbOper=1,
            quality = quality,
            level=level,
            link = link
          }
        else
          -- il y a une entrée précédente dans le journal, cumul des count
          entry.count = entry.count + addCount
          entry.nbOper = entry.nbOper + 1
          -- pour la restitution, on conserve la derniere date/heure disponible
          if eventTime > entry.timestamp then entry.timestamp = eventTime end
        end
      end
    end
  end
  return operations, oldestTimestamp, newestTimestamp
end

--[[
--------------------------------------------------------                    
  _____              _______ _                     
 / ____|            |__   __(_)                    
| (___  _   _ _ __     | |   _ _ __ ___   ___ _ __ 
 \___ \| | | | '__|    | |  | | '_ ` _ \ / _ \ '__|
 ____) | |_| | |       | |  | | | | | | |  __/ |   
|_____/ \__,_|_|       |_|  |_|_| |_| |_|\___|_|   
                               
-------------------------------------------------------- 
]]--

-------------------------------------------------------- 
-- Banque potentiellement disponible
-- Attente du délai apres réception des events de reception du contenu depuis le server
-------------------------------------------------------- 
local function bankMayBeAvailable()

  -- Verification que les conditions techniques de scan sont ok
  if not k_GBH.ScanTargetTime then
    -- la banque n'est plus acessible ou le scan a été fait
    -- d(k_GBH.L.BankNotAvailable) 
    return
  end
  if GetFrameTimeMilliseconds() < k_GBH.ScanTargetTime then
    -- un evenement de chargement de banque a été recu, et le delai d'analyse n'est pas arrivé, la fonction sera appelée plus tard
    d(k_GBH.L.BankScanRescheduled)
    return
  end

  -- bank disponible
  k_GBH.ScanTargetTime = nil
  setGameBankAvailable(true)

end

-------------------------------------------------------- 
-- Requete de recuperation des derniers historiques des banques....
-- appelée sur timer
-------------------------------------------------------- 
local function getNextGuildBankJournal()
  -- Si il y a une demande explicite de delay pour charger les banques (cas ou debut...)
  if k_GBH.defferedScan > 0 then
    -- On supprime un delai de scan et on ne fait rien.... pour l'instant
    k_GBH.defferedScan = k_GBH.defferedScan - 1
  -- On peut faire une recup.... mais on vérifie qu'on n'est pas en mode combat
  elseif not k_GBH.combatMode then 
    -- on tente la récupération uniquement hors mode combat pour éviter les lags
    local now = GetTimeStamp()
    for guildIndex = 1, GetNumGuilds() do
      local guildbankid = GetGuildId(guildIndex)
      local bankName=GetGuildName(guildbankid)
      local bank = getBank(bankName)
      -- si tracking actif sur cette banque
      if bank.alertWithdrawQuality or bank.alertDepositQuality or bank.alertWithdrawLevel or bank.alertDepositLevel or bank.alertWithdrawGold or bank.alertDepositGold then
        -- si date de scan dépassée 
        if bank.scheduledGetJournal <= now then
          -- calcule la prochaine echéance
          bank.scheduledGetJournal = now +  math.random (k_GBH.cAutoScanMin,k_GBH.cAutoScanMax)
          D('Request history of bankName '..bankName)
          -- requete le dernier historique
          RequestGuildHistoryCategoryNewest(guildbankid, GUILD_HISTORY_BANK)
        end
      else
        -- pas de tracking actif 
        if bank.journal then
          bank.journal = nil
        end
      end
    end
  end
  -- appel cyclique inconditionnel toutes les cCyclicTimer secondes  
  zo_callLater(getNextGuildBankJournal, k_GBH.cCyclicTimer * 1000)
end

--[[
--------------------------------------------------------                    
  _____              ______               _   
 / ____|            |  ____|             | |  
| (___  _   _ _ __  | |____   _____ _ __ | |_ 
 \___ \| | | | '__| |  __\ \ / / _ \ '_ \| __|
 ____) | |_| | |    | |___\ V /  __/ | | | |_ 
|_____/ \__,_|_|    |______\_/ \___|_| |_|\__|
                                              
-------------------------------------------------------- 
]]--

-------------------------------------------------------- 
-- Evenement de disponibilité des items en banque recu....
-------------------------------------------------------- 
local function do_EVENT_GUILD_BANK_ITEMS_READY(code)
  D('EVENT_GUILD_BANK_ITEMS_READY')
  -- indique que le scan est possible, à partir d'un certain delay pour permettre le load des items
  k_GBH.ScanTargetTime = GetFrameTimeMilliseconds() + getButtonDelay()
  zo_callLater(bankMayBeAvailable, getButtonDelay())
end

-------------------------------------------------------- 
-- Divers evenement 
-------------------------------------------------------- 
local function do_EVENT_GUILD_BANK_OPEN_ERROR()
  D('EVENT_GUILD_BANK_OPEN_ERROR')
  setGameBankAvailable(false)
end
-------------------------------------------------------- 
-- Divers evenement 
-------------------------------------------------------- 
local function do_EVENT_CLOSE_GUILD_BANK()
  D('EVENT_CLOSE_GUILD_BANK')
  setGameBankAvailable(false)
end
-------------------------------------------------------- 
-- Divers evenement 
-------------------------------------------------------- 
local function do_EVENT_OPEN_GUILD_BANK()
  D('EVENT_OPEN_GUILD_BANK')
  setGameBankAvailable(false)
end
-------------------------------------------------------- 
-- Divers evenement 
-------------------------------------------------------- 
local function do_EVENT_GUILD_BANK_SELECTED()
  D('EVENT_GUILD_BANK_SELECTED')
  setGameBankAvailable(false)
end
-------------------------------------------------------- 
-- Divers evenement 
-------------------------------------------------------- 
local function do_EVENT_GUILD_BANK_DESELECTED()
  D('EVENT_GUILD_BANK_DESELECTED')
  setGameBankAvailable(false)
end
-------------------------------------------------------- 
-- Ajout d'un truc dans la banque
-- en cas de mouvement dans la banque, on masque l'UI
-------------------------------------------------------- 
local function do_EVENT_GUILD_BANK_ITEM_ADDED(...)
  D('EVENT_GUILD_BANK_ITEM_ADDED',...)
  uiHide()
end
-------------------------------------------------------- 
-- Retrait d'un truc dans la banque
-- en cas de mouvement dans la banque, on masque l'UI
-------------------------------------------------------- 
local function do_EVENT_GUILD_BANK_ITEM_REMOVED(...)
  D('EVENT_GUILD_BANK_ITEM_REMOVED',...)
  uiHide()
end
-------------------------------------------------------- 
-- Operation d'un truc dans la banque
-- en cas de mouvement dans la banque, on masque l'UI
-------------------------------------------------------- 
local function do_EVENT_GUILD_BANK_UPDATED_QUANTITY(...)
  D('EVENT_GUILD_BANK_UPDATED_QUANTITY,...')
  uiHide()
end



-------------------------------------------------------- 
-- Reception d'un paquet de mouvement depuis l'historique de banque de guilde
-------------------------------------------------------- 
local function do_EVENT_GUILD_HISTORY_RESPONSE_RECEIVED(eventCode, guildId, category)
    D('EVENT_GUILD_HISTORY_RESPONSE_RECEIVED')
    
    if category == GUILD_HISTORY_BANK then
        local bankName = GetGuildName(guildId)
        D("Response received for bankName: ",bankName)
        
        -- Si besoin, creation d'une entrée dans l'historique
        local bank = getBank(bankName)

        -- Determine la date/heure de la derniere entrée maximale dans le journal 
        local lastOperationTimestamp = (bank.journal and bank.journal.lastOperationTimestamp) or 0

        -- Determine la date/heure du dernier scan
        local lastScanTimestamp = (bank.journal and bank.journal.lastScanTimestamp) or 0

        D('old lastOperationTimestamp=',lastOperationTimestamp) 
        D('old lastScanTimeStamp=',lastScanTimestamp) 
        
        -- scan de la reponse du server, pour compactage par compte/linkObjet, avec cumul sur les recents si ils exitent
        local operations, oldestTimestamp,newestOperationTimestamp = scanServerResponse(guildId,lastOperationTimestamp,bank.recentOperations)

        if operations==nil then
          -- aucune réponse réellement recu, on retourne comme si on n'avait pas recu l'event
          return
        end
        D('timestamps of operations from server',oldestTimestamp, newestOperationTimestamp) 
        
        --[[
        
        l'API sur la banque de guilde semble ne pas accepter la requete RequestGuildHistoryCategoryOlder
        dont cette sequence est annulée, car il semble impossible de completer l'historique 
        au dela du résultat de la requete RequestGuildHistoryCategoryNewest
        
        -- Si la plus vieille operation du journal est apres le dernier scan, et que les anciens ne sont pas demandés,
        -- il peut manquer des elements, donc on tente de completer avec des mouvements + anciens
        if (oldestTimestamp > lastScanTimestamp) and (not bank.recentOperations) then
            -- on sauvegarde les operations actuelles
            bank.recentOperations = operations
            -- recupere les mouvement + anciens
            D("Querying oldest movements for bankName: ",bankName)
            RequestGuildHistoryCategoryOlder(guildId, GUILD_HISTORY_BANK)
            -- le traitement se poursuivra quand l'historique suivant de la banque sera recu
            return
        end
        -- on supprime les recents dans tous les cas, car ils sont déjà cumulés dans operations
        bank.recentOperations = nil

        ]]--

        -- le journal cumulé est le précédent journal des operations ou vide
        local globalOperations = (bank.journal and bank.journal.operations) or {}
        
        -- Si le plus ancien de l'historique est postérieur au dernier scan, alerte le joueur de mouvements manquants
        -- (mais uniquement si un scan avait deja eu lieu)
        if lastScanTimestamp  and (lastScanTimestamp > 0) and (oldestTimestamp > lastScanTimestamp) then
          local msg = zo_strformat(k_GBH.L.Missing,bankName,getFullDateTime(lastScanTimestamp),getFullDateTime(oldestTimestamp))
          uiAlertMessage(msg) 
          d(msg)
          -- Insere un element indiquant qu'il peut manquer des mouvements dans la banque de guilde
          table.insert(globalOperations, { timestamp = lastScanTimestamp, gapStart = lastScanTimestamp , gapEnd= oldestTimestamp})
        end
        
        -- on balaye maintenant le nouveau journal pour déterminer les alertes potentielles, et cumuler dans le journal précédent
        for _,entry in pairs(operations) do
          -- ajoute dans le journal cumulé ce dernier mouvement
          table.insert(globalOperations,entry)
          -- si timestamp de l'entry apres la derniere phase d'analyse, alerte possible (sinon, déjà fait)
          if entry.timestamp > lastOperationTimestamp then
            -- si l'entrée n'est pas associé au joueur actuel
            if k_GBH.selfName ~= entry.player then
              -- test si alerte sur depot
              if (entry.count > 0) then
                if entry.link and ((bank.alertDepositQuality and (entry.quality >= bank.alertDepositQuality)) or (bank.alertDepositLevel and entry.level and (entry.level >= bank.alertDepositLevel))) then
                  -- Si alert sur objet 
                  local message = zo_strformat(k_GBH.L.AlertJournalOperationAdd,bankName, entry.player, getFullDateTime(entry.timestamp),entry.count,entry.link)
                  uiPutInAlertQueue(bankName,message,entry.quality,'a')
                elseif (entry.link == nil) and bank.alertDepositGold then
                  -- Si alert sur PO 
                  local message = zo_strformat(k_GBH.L.AlertJournalOperationAddPo,bankName, entry.player, getFullDateTime(entry.timestamp),entry.count)
                  uiPutInAlertQueue(bankName,message,'po','a')
                end
              end
              -- test si alerte sur retrait
              if (entry.count < 0) then
                if entry.link and (k_GBH.selfName ~= entry.player) and ((bank.alertWithdrawQuality and (entry.quality >= bank.alertWithdrawQuality)) or (bank.alertWithdrawLevel and entry.level and (entry.level >= bank.alertWithdrawLevel))) then
                  local message = zo_strformat(k_GBH.L.AlertJournalOperationDel,bankName, entry.player, getFullDateTime(entry.timestamp),- entry.count,entry.link)
                  uiPutInAlertQueue(bankName,message,entry.quality,'r')
                elseif (entry.link == nil) and bank.alertWithdrawGold then
                  -- Si alert sur PO 
                  local message = zo_strformat(k_GBH.L.AlertJournalOperationDelPo,bankName, entry.player, getFullDateTime(entry.timestamp),- entry.count)
                  uiPutInAlertQueue(bankName,message,'po','r')
                end
              end
            end
          end
        end
        
        -- tri du journal cumulé
        table.sort(globalOperations, function (a,b) return a.timestamp < b.timestamp end )

        -- Si le journal est trop important, on le tronque
        -- d('#globalOperations', #globalOperations .. ' ' .. bankName)
        if (#globalOperations) > k_GBH.cJournalCountMax then
            local nbDel = (#globalOperations) - k_GBH.cJournalCountObj
            for i=1, nbDel do
              table.remove(globalOperations,1)
            end
        end
         
        
        -- on conserve le dernier journal cumulé pour affichage et analyse ultérieure
        bank.journal = 
        { 
          lastScanTimestamp = GetTimeStamp(), 
          operations = globalOperations,
          lastOperationTimestamp=newestOperationTimestamp
        }
        -- journal.lastOperationTimestamp devrait etre lastOperationTimestamp dans tous les cas, 
        -- mais il y a une incohérence temporelle dans GetGuildEventInfo entrainant la possibilité
        -- qu'un event puisse se décaler d'une seconde entre différents appels a GetGuildEventInfo
        -- Aka dans un premier scan eventTime=10 et un appel suivant eventTime=11
        -- Ceci pouvant alors entrainer l'affichage de 2 alertes sur l'item concerné, lors des 2 scans
        -- Aussi, selon la date/heure de scan, on peut choisir de positionner lastOperationTimestamp a maxTimeStamp+1 si 
        -- ce scan a lieu apres plus de 5 secondes depuis le maxTimeSTamp, considerant que pour 5 secondes, l'historique devrait etre a jour
        -- Ainsi, si dans un scan suivant, même le dernier element est décalé d'une seconde, il ne sera pas pris en compte
        -- il reste un probleme si le scan a lieu exactement quand une depose est réalisée... dans ce cas, il peut y avoir des alertes en double
        if bank.journal.lastScanTimestamp >= bank.journal.lastOperationTimestamp + 5 then
          D('bank.journal.lastOperationTimestamp updated to fix lags in API')
          bank.journal.lastOperationTimestamp = bank.journal.lastOperationTimestamp+1
        end
        
        D('new lastOperationTimestamp=',bank.journal.lastOperationTimestamp)

    end
end




-------------------------------------------------------- 
-- mode combat
-------------------------------------------------------- 
local function do_EVENT_PLAYER_COMBAT_STATE(eventId, mode)
  D('EVENT_PLAYER_COMBAT_STATE')
  k_GBH.combatMode = mode
  if mode then
    uiHide(true)
  end
end

-------------------------------------------------------- 
-- joueur activé (au debut ou changement de zones)
-------------------------------------------------------- 
local function do_EVENT_PLAYER_ACTIVATED(eventId)
  D('EVENT_PLAYER_ACTIVATED')
  -- Teste si la sequence d'activation a déjà eu lieue
  if not k_GBH.welcomeDone then
    -- Ceci est la premiere fois depuis le chargement que EVENT_PLAYER_ACTIVATED est lancé, on fait le job
    k_GBH.welcomeDone = true
    d(zo_strformat(k_GBH.L.Welcome,k_GBH.version))
    -- si conversion des savedVariables, on l'indique
    if k_GBH.savedVariablesConverted then
      d(zo_strformat(k_GBH.L.Converted,k_GBH.savedVariablesConverted, k_GBH.savedVariables.savedVersion))
    end
    -- Charge les journaux des banques
    getNextGuildBankJournal()
  end

end

--[[
--------------------------------------------------------                    
  ____                                          _ 
 / ___|___  _ __ ___  _ __ ___   __ _ _ __   __| |
| |   / _ \| '_ ` _ \| '_ ` _ \ / _` | '_ \ / _` |
| |__| (_) | | | | | | | | | | | (_| | | | | (_| |
 \____\___/|_| |_| |_|_| |_| |_|\__,_|_| |_|\__,_|
                                                  
-------------------------------------------------------- 
]]--


-------------------------------------------------------- 
-- Commande /gbh
-------------------------------------------------------- 
local function command(cmd)
  if cmd== "" then
    -- /gbh
    uiShow('j')
  elseif cmd=='?' or cmd=="help" then
    -- /gbh help or /gbh ?
    d(k_GBH.L.Syntax)
  elseif cmd=="detail" then
    -- /gbh detail
    k_GBH.savedVariables.displayDetailsInChat = not k_GBH.savedVariables.displayDetailsInChat
    d('BankHistory: detail '.. ((k_GBH.savedVariables.displayDetailsInChat and 'on') or 'off') )
  elseif string.sub(cmd,1,6)=="delay " then
    -- /gbh delay n
    local n = tonumber(string.sub(cmd,7)) or k_GBH.cDefaultDefferedScan
    n = (n<0 and 0) or (n>6 and 6) or n 
    setDefferedScan(n)
    df('BankHistory: new initial scan delay is %d*%d (%d) seconds', n, k_GBH.cCyclicTimer, n * k_GBH.cCyclicTimer)
  elseif string.sub(cmd,1,7)=="button " then
    -- /gbh button n
    local n = tonumber(string.sub(cmd,8)) or k_GBH.cDefaultButtonDelay
    n = (n<3 and 3) or (n>10 and 10) or n 
    setButtonDelay(n * 500)
    df('BankHistory: new button delay availability is %d*0.5 (%2.1f) seconds', n, n * 0.5)
  elseif cmd=="debug" then
    -- /gbh debug
    k_GBH.debug = not k_GBH.debug
    d('BankHistory: debug '.. ((k_GBH.debug and 'on') or 'off') )
  elseif cmd=="load" then
    -- /gbh load
    d('BankHistory: loading journals')
    getNextGuildBankJournal()
  elseif cmd=="test" then
    -- /gbh test
    d('BankHistory: test......')
  else
    d(k_GBH.L.SyntaxError)
  end


  



end  

--[[
-------------------------------------------------------- 
  ____ _           _   ____        _   _              
 / ___| |__   __ _| |_| __ ) _   _| |_| |_ ___  _ __  
| |   | '_ \ / _` | __|  _ \| | | | __| __/ _ \| '_ \ 
| |___| | | | (_| | |_| |_) | |_| | |_| || (_) | | | |
 \____|_| |_|\__,_|\__|____/ \__,_|\__|\__\___/|_| |_|
                                                      
Code from craftstore (modified)
-------------------------------------------------------- 
]]--
local function drawButton(arg)
  local n,p=arg.name ,arg.parent or CS_Screen
  local c=WINDOW_MANAGER:CreateControl(n,p,CT_BUTTON)
  c:SetState(BSTATE_NORMAL)
  if arg.tooltip then
    c.data={tooltipText=arg.tooltip}
    c:SetHandler("OnMouseEnter",ZO_Options_OnMouseEnter)
    c:SetHandler("OnMouseExit",ZO_Options_OnMouseExit)
  end
  if arg.enter then c:SetHandler("OnMouseEnter",function(self,...)arg.enter(self,...)end)end
  if arg.leave then c:SetHandler("OnMouseExit",function(self,...)arg.leave(self,...)end)end
  if arg.text then
    c:SetText(arg.text)
    if arg.halign then c:SetHorizontalAlignment(arg.halign) end
    if arg.valign then c:SetVerticalAlignment(arg.valign) end
    if arg.font then c:SetFont(arg.font)else c:SetFont("ZoFontGame")end
    if arg.color then c:SetNormalFontColor(arg.color[1],arg.color[2],arg.color[3],arg.color[4])else c:SetNormalFontColor(1,1,1,1)end
    if arg.colorHover then c:SetMouseOverFontColor(arg.colorHover[1],arg.colorHover[2],arg.colorHover[3],arg.colorHover[4])end
  end
  if arg.icon then c:SetNormalTexture(arg.icon)end
  if arg.iconHover then c:SetMouseOverTexture(arg.iconHover)end
  if arg.full then c:SetAnchorFill()else
    if arg.anchor then c:SetAnchor(arg.anchor[1],arg.anchor[2],arg.anchor[3],arg.anchor[4],arg.anchor[5])else c:SetAnchor(CENTER,p,CENTER,0,0)end
    if arg.size then c:SetDimensions(arg.size[1],arg.size[2])else c:SetDimensions(25,25)end
  end
  c:SetClickSound("Click")
  if arg.func then c:SetHandler("OnClicked",function(self,...)arg.func(self,...)end)end
  if arg.layer then c:SetDrawLayer(arg.layer) end
  return c
end

local function drawChatButton()
  drawButton({name="k_GBH_ChatButton",parent=ZO_ChatWindowOptions,tooltip="GuildBankHistory",icon="esoui/art/guild/guild_bankaccess.dds",iconHover="esoui/art/buttons/generic32x32mouseover.dds",size={36,36},anchor={TOPRIGHT,ZO_ChatWindowOptions,TOPRIGHT,-70,-1},func=function()command("")end})
end

--[[
--------------------------------------------------------                    
 _____       _ _   _       _ _           _   _             
|_   _|     (_) | (_)     | (_)         | | (_)            
  | |  _ __  _| |_ _  __ _| |_ ___  __ _| |_ _  ___  _ __  
  | | | '_ \| | __| |/ _` | | / __|/ _` | __| |/ _ \| '_ \ 
 _| |_| | | | | |_| | (_| | | \__ \ (_| | |_| | (_) | | | |
|_____|_| |_|_|\__|_|\__,_|_|_|___/\__,_|\__|_|\___/|_| |_|

-------------------------------------------------------- 
]]--

 
-------------------------------------------------------- 
-- Initialisation du plugins
-------------------------------------------------------- 
local function onLoad(eventCode, name)
	-- si pas d'actualité.... retourne
	if name ~= k_GBH.name then return end

	-- unregister du chargement du plugin
	EVENT_MANAGER:UnregisterForEvent(k_GBH.name, EVENT_ADD_ON_LOADED)

  -- Verification que l'UI est bien disponible et donc pas d'erreur dans l'XML
  assert(k_GBH_,"k_GBH_ (the UI) is not defined")


	-- Chargement des variables sauvegardées
	k_GBH.savedVariables = ZO_SavedVars:NewAccountWide("GuildBankHistory", 1, nil, nil)

  -- Retablissement des savedVariables manquantes en fonction de la version
	-- Complete les savedVariables si besoin
  normalizeSavedVariables()

  -- setup parametres
  setDefferedScan(k_GBH.savedVariables.defferedScan)
  setButtonDelay(k_GBH.savedVariables.buttonDelay)

  -- initialisation de l'ui
  uiInit()
  -- chat button 
  drawChatButton()
  
  
  	-- Handler d'event
	EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_GUILD_BANK_ITEMS_READY, do_EVENT_GUILD_BANK_ITEMS_READY)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_GUILD_BANK_OPEN_ERROR, do_EVENT_GUILD_BANK_OPEN_ERROR)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_CLOSE_GUILD_BANK, do_EVENT_CLOSE_GUILD_BANK)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_OPEN_GUILD_BANK, do_EVENT_OPEN_GUILD_BANK)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_GUILD_BANK_SELECTED, do_EVENT_GUILD_BANK_SELECTED)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_GUILD_BANK_DESELECTED, do_EVENT_GUILD_BANK_DESELECTED)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_GUILD_BANK_ITEM_ADDED, do_EVENT_GUILD_BANK_ITEM_ADDED)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_GUILD_BANK_ITEM_REMOVED, do_EVENT_GUILD_BANK_ITEM_REMOVED)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_GUILD_HISTORY_RESPONSE_RECEIVED, do_EVENT_GUILD_HISTORY_RESPONSE_RECEIVED)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_PLAYER_COMBAT_STATE, do_EVENT_PLAYER_COMBAT_STATE)
  EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_PLAYER_ACTIVATED, do_EVENT_PLAYER_ACTIVATED)
  
	-- Commande /gbh
	SLASH_COMMANDS[k_GBH.L.command] = command

end

-------------------------------------------------------- 
-- Positionne le handler de chargement du plugin à appeler après chargement initial des différents codes
-------------------------------------------------------- 
EVENT_MANAGER:RegisterForEvent("GuildBankHistory", EVENT_ADD_ON_LOADED, onLoad)


